SoRotateDiscDragger(3)

NAME
SoRotateDiscDragger - The SoRotateDiscDragger class is for rotating geometry around a single axis.

SYNOPSIS

#include <Inventor/draggers/SoRotateDiscDragger.h>

Inherits SoDragger.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual const SoNodekitCatalog * getNodekitCatalog (void) const
SoRotateDiscDragger (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static const SoNodekitCatalog * getClassNodekitCatalog (void)
static void initClass (void)

  Public Attributes
SoSFRotation rotation

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoRotateDiscDragger (void)
virtual SbBool setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
void dragStart (void)
void drag (void)
void dragFinish (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static const SoNodekitCatalog ** getClassNodekitCatalogPtr (void)
static void startCB (void *f, SoDragger *d)
static void motionCB (void *f, SoDragger *d)
static void doneCB (void *f, SoDragger *d)
static void fieldSensorCB (void *f, SoSensor *s)
static void valueChangedCB (void *f, SoDragger *d)

  Protected Attributes
SoSFNode feedback
SoSFNode feedbackActive
SoSFNode feedbackSwitch
SoSFNode rotator
SoSFNode rotatorActive
SoSFNode rotatorSwitch
SoFieldSensor * fieldSensor
SbPlaneProjector * planeProj

  Additional Inherited Members

Detailed Description

The SoRotateDiscDragger class is for rotating geometry around a single axis. Here's how the dragger looks with its default geometry in the inactive state:

 Screen Shot of Default Dragger

Use an instance of this dragger class in your scene graph to let the end-users of your application rotate geometry around a predefined axis vector in 3D.

The special feature of this dragger that sets it apart from the other draggers that provides rotation around an axis (like the SoRotateCylindricalDragger) is that it provides a convenient interface to rotate around an axis that is pointing in approximately the same direction as the camera. This is useful for interacting with for instance something like a 'volume' knob.

For the dragger orientation and positioning itself, use some kind of transformation node in your scene graph, as usual.

Constructor & Destructor Documentation

  SoRotateDiscDragger::SoRotateDiscDragger (void)
Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

CLASS SoRotateDiscDragger
-->'this'
      'callbackList'
      'topSeparator'
         'motionMatrix'
         'geomSeparator'
-->         'rotatorSwitch'
-->            'rotator'
-->            'rotatorActive'
-->         'feedbackSwitch'
-->            'feedback'
-->            'feedbackActive'

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

CLASS SoRotateDiscDragger
PVT   'this',  SoRotateDiscDragger  ---
      'callbackList',  SoNodeKitListPart [ SoCallback, SoEventCallback ]
PVT   'topSeparator',  SoSeparator  ---
PVT   'motionMatrix',  SoMatrixTransform  ---
PVT   'geomSeparator',  SoSeparator  ---
PVT   'rotatorSwitch',  SoSwitch  ---
      'rotator',  SoSeparator  ---
      'rotatorActive',  SoSeparator  ---
PVT   'feedbackSwitch',  SoSwitch  ---
      'feedback',  SoSeparator  ---
      'feedbackActive',  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

  SoRotateDiscDragger::~SoRotateDiscDragger (void) [protected], [virtual]
Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

Member Function Documentation

  SoType SoRotateDiscDragger::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoRotateDiscDragger::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoDragger.

  const SoFieldData ** SoRotateDiscDragger::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoRotateDiscDragger::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoDragger.

  const SoNodekitCatalog * SoRotateDiscDragger::getClassNodekitCatalog (void) [static]
Returns the nodekit catalog which defines the layout of this class' kit.

  const SoNodekitCatalog * SoRotateDiscDragger::getNodekitCatalog (void) const [virtual]
Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

  const SoNodekitCatalog ** SoRotateDiscDragger::getClassNodekitCatalogPtr (void) [static], [protected]
Returns the pointer to the pointer of the nodekit catalog for this class.

  void SoRotateDiscDragger::initClass (void) [static]
Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

  SbBool SoRotateDiscDragger::setUpConnections (SbBool onoff, SbBool doitalways = FALSE) [protected], [virtual]
Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

  void SoRotateDiscDragger::startCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateDiscDragger::motionCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateDiscDragger::doneCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateDiscDragger::fieldSensorCB (void * d, SoSensor * s) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateDiscDragger::valueChangedCB (void * f, SoDragger * d) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoRotateDiscDragger::dragStart (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

  void SoRotateDiscDragger::drag (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

  void SoRotateDiscDragger::dragFinish (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

Member Data Documentation

  SoSFRotation SoRotateDiscDragger::rotation
This field is continuously updated to contain the rotation of the current direction vector of the dragger.

The application programmer using this dragger in his scene graph should connect the relevant node fields in the scene to this field to make them follow the dragger orientation.

  SoFieldSensor * SoRotateDiscDragger::fieldSensor [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SbPlaneProjector * SoRotateDiscDragger::planeProj [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Author

Generated automatically by Doxygen for Coin from the source code.